####################################################
# [U[p[^ǉ̊ȗCu Ver.1.0 #
# Copyright (C) 2011 moon All Rights Reserved.     #
# http://www11.big.or.jp/~hazymoon/index.htm       #
####################################################

package UserParamLib;

#### ݒ荀 ####
my $name_file = './user_param_def.pl'; # [U[p[^`t@C̃pX
my $package_name = 'main'; # [U[p[^ϐpbP[W̖O
my $error_sub_ref = \&main::error; # G[ɌĂяoTu[`t@X
#### ܂Őݒ荀 ####

my %name_hash = (); # t@CL[Ƃ郆[U[p[^̃nbV

# e[U[p[^ϐXV
# yz
#     up[^̃vtBbNXv ܂ u`t@CpX̃XJ[t@Xv
#     [U[f[^
# y߂lz
#     Ȃ
# yz
#      $lineɂ̓[U[f[^i'ID<>O<>pX[h<>EEE'jĂ̂Ƃ
#      $fileɂ͒`t@CpXi'./example.pl'jĂ̂Ƃ
#     1F ̃[U[p[^XVꍇ
#         &UserParamLib::deserialize('', $line);
#     2F ̃[U[p[^XVꍇ
#         &UserParamLib::deserialize('p', $line);
#     3F ʂ̒`t@Cgpă[U[p[^XVꍇ
#         &UserParamLib::deserialize(\$file, $line);
sub deserialize{
	my $param = shift;
	my $data = shift;

	my @list = split(/\Q<>\E/, $data);
	my ($nameListRef, $prefix) = &get_config($param);
	foreach my $index (0 .. $#$nameListRef){
		${$prefix . $nameListRef->[$index]} = $index < @list && $list[$index] ne "\n" ? $list[$index] : '';
	}
}

# e[U[p[^ϐt@Cۑp̃[U[f[^쐬
# yz
#     up[^̃vtBbNXv ܂ u`t@CpX̃XJ[t@Xv
# y߂lz
#     [U[f[^i"ID<>O<>pX[h<>EEE<>\n"j
# yz
#      $fileɂ͒`t@CpXiႦ'./example.pl'jĂ̂Ƃ
#     1F ̃[U[f[^쐬ꍇ
#         &UserParamLib::serialize('');
#     2F ̃[U[f[^쐬ꍇ
#         &UserParamLib::serialize('p');
#     3F ʂ̒`t@Cgpă[U[f[^쐬ꍇ
#         &UserParamLib::serialize(\$file);
sub serialize{
	my $param = shift;

	my @list = ();
	my ($nameListRef, $prefix) = &get_config($param);
	my $fullName;
	foreach my $name (@$nameListRef){
		$fullName = $prefix . $name;
		push(@list, defined($$fullName) ? $$fullName : '');
	}
	return join('<>', @list, "\n");
}

# pF [U[p[^`t@CpXƃ[U[p[^̃vtBbNX擾
# yz
#     up[^̃vtBbNXv ܂ u`t@CpX̃XJ[t@Xv
# y߂lz
#     ('[U[p[^`t@CpX', '[U[p[^̃vtBbNX')
sub get_config{
	my $param = shift;

	my $file;
	my $prefix;
	if(ref($param) eq 'SCALAR'){
		# w肳ꂽ`t@Cgpꍇ
		$file = $$param;
		$prefix = '';
	}
	else{
		# ftHg̒`t@Cgpꍇ
		$file = $name_file;
		$prefix = scalar($param);
	}
	# `t@Cǂݍ܂ĂȂꍇ͓ǂݍ
	unless(exists($name_hash{$file})){
		local ($@, $!);
		my @list = do $file;
		$error_sub_ref->($@ ne '' ? $@ : $!) if(($@ ne '' || $! ne '') && ref($error_sub_ref) eq 'CODE');
		$name_hash{$file} = \@list;
	}
	return ($name_hash{$file}, $package_name . '::' . $prefix);
}

1;
